/* livechart.vapi generated by valac 0.52.4, do not modify. */

namespace LiveChart {
	[CCode (cheader_filename = "livechart.h")]
	public class Area : LiveChart.Drawable, GLib.Object {
		public Area (LiveChart.Points points, Gdk.RGBA main_color, double alpha);
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Background : LiveChart.Drawable, GLib.Object {
		public Background ();
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Bar : LiveChart.DrawableSerie {
		public Bar (LiveChart.Values values = new LiveChart.Values (1000));
		public override void draw (Cairo.Context ctx, LiveChart.Config config);
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Bounds : GLib.Object {
		public Bounds (double lower = double.NAN, double upper = double.NAN);
		public bool has_lower ();
		public bool has_upper ();
		public bool update (double value);
		public double lower { get; private set; }
		public double upper { get; private set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Chart : Gtk.DrawingArea {
		public LiveChart.Config config;
		public Chart (LiveChart.Config config = new LiveChart.Config ());
		public void add_serie (LiveChart.Serie serie);
		public void add_unaware_timestamp_collection (LiveChart.Serie serie, Gee.Collection<double?> collection, int timespan_between_value);
		public void add_unaware_timestamp_collection_by_index (int serie_index, Gee.Collection<double?> collection, int timespan_between_value);
		public void add_value (LiveChart.Serie serie, double value);
		public void add_value_by_index (int serie_index, double value);
		public void refresh_every (int ms);
		public void to_png (string filename) throws GLib.Error;
		public LiveChart.Drawable background { get; set; }
		public LiveChart.Grid grid { get; set; }
		public LiveChart.Legend legend { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Config {
		public LiveChart.Padding padding;
		public LiveChart.XAxis x_axis;
		public LiveChart.YAxis y_axis;
		public Config ();
		public LiveChart.Boundaries boundaries ();
		public void configure (Cairo.Context ctx, LiveChart.Legend? legend);
		public int height { get; set; }
		public int width { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public abstract class DrawableSerie : LiveChart.Drawable, GLib.Object {
		protected LiveChart.BoundingBox bounding_box;
		protected LiveChart.Values values;
		protected DrawableSerie ();
		protected void debug (Cairo.Context ctx);
		public abstract void draw (Cairo.Context ctx, LiveChart.Config config);
		public LiveChart.Values get_values ();
		protected bool is_out_of_area (LiveChart.Point point);
		public double outline_width { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Font {
		public Font ();
		public void configure (Cairo.Context ctx);
		public Gdk.RGBA color { get; set; }
		public string face { get; set; }
		public uint8 size { get; set; }
		public Cairo.FontSlant slant { get; set; }
		public Cairo.FontWeight weight { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Grid : LiveChart.Drawable, GLib.Object {
		protected LiveChart.BoundingBox bounding_box;
		public const int ABSCISSA_TIME_PADDING;
		public Grid ();
		protected void debug (Cairo.Context ctx);
		protected void render_abscissa (Cairo.Context ctx, LiveChart.Config config);
		protected void render_grid (Cairo.Context ctx, LiveChart.Config config);
		protected void render_hgrid (Cairo.Context ctx, LiveChart.Config config);
		protected void render_ordinate (Cairo.Context ctx, LiveChart.Config config);
		protected void render_vgrid (Cairo.Context ctx, LiveChart.Config config);
		protected void restore (Cairo.Context ctx);
		protected void update_bounding_box (LiveChart.Config config);
	}
	[CCode (cheader_filename = "livechart.h")]
	public class HorizontalLegend : LiveChart.Legend {
		public HorizontalLegend ();
		protected void debug (Cairo.Context ctx);
		public override void draw (Cairo.Context ctx, LiveChart.Config config);
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Labels {
		public Labels ();
		public Cairo.TextExtents extents { get; set; }
		public LiveChart.Font font { get; set; }
		public bool visible { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public abstract class Legend : LiveChart.Drawable, GLib.Object {
		protected LiveChart.BoundingBox bounding_box;
		public LiveChart.Labels labels;
		protected Gee.ArrayList<LiveChart.Serie> series;
		protected Legend ();
		public void add_legend (LiveChart.Serie serie);
		public abstract void draw (Cairo.Context ctx, LiveChart.Config config);
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Line : LiveChart.DrawableSerie {
		public Line (LiveChart.Values values = new LiveChart.Values (1000));
		public override void draw (Cairo.Context ctx, LiveChart.Config config);
		protected LiveChart.Points draw_line (LiveChart.Points points, Cairo.Context ctx, LiveChart.Config config);
	}
	[CCode (cheader_filename = "livechart.h")]
	public class LineArea : LiveChart.Line {
		public LineArea (LiveChart.Values values = new LiveChart.Values (1000));
		public override void draw (Cairo.Context ctx, LiveChart.Config config);
		public double area_alpha { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class NoopLegend : LiveChart.Legend {
		public NoopLegend ();
		public override void draw (Cairo.Context ctx, LiveChart.Config config);
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Path : GLib.Object {
		public LiveChart.Dash? dash;
		public Path ();
		public void configure (Cairo.Context ctx);
		public Gdk.RGBA color { get; set; }
		public bool visible { get; set; }
		public double width { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Points : GLib.Object {
		public Points ();
		public void add (LiveChart.Point point);
		public LiveChart.Point after (int at);
		public static LiveChart.Points create (LiveChart.Values values, LiveChart.Config config);
		public LiveChart.Point first ();
		public new LiveChart.Point @get (int at);
		public LiveChart.Point last ();
		public LiveChart.Bounds bounds { get; set construct; }
		public double realtime_delta { get; set; }
		public int size { get; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Serie : LiveChart.Drawable, GLib.Object {
		public Serie (string name, LiveChart.DrawableSerie renderer = new LiveChart.Line (new LiveChart.Values (1000)));
		public void add (LiveChart.TimestampedValue value);
		public void clear ();
		public Gdk.RGBA get_main_color ();
		public LiveChart.Values get_values ();
		public void set_main_color (Gdk.RGBA color);
		public string name { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class SmoothLine : LiveChart.DrawableSerie {
		public SmoothLine (LiveChart.Values values = new LiveChart.Values (1000));
		public override void draw (Cairo.Context ctx, LiveChart.Config config);
		public void draw_smooth_line (LiveChart.Points points, Cairo.Context ctx, LiveChart.Config config);
	}
	[CCode (cheader_filename = "livechart.h")]
	public class SmoothLineArea : LiveChart.SmoothLine {
		public SmoothLineArea (LiveChart.Values values = new LiveChart.Values (1000));
		public override void draw (Cairo.Context ctx, LiveChart.Config config);
		public double area_alpha { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class Values : Gee.LinkedList<LiveChart.TimestampedValue?> {
		public Values (int buffer_size = 1000);
		public new void add (LiveChart.TimestampedValue value);
		public LiveChart.Bounds bounds { get; set construct; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class XAxis {
		public LiveChart.Path axis;
		public LiveChart.Labels labels;
		public LiveChart.Path lines;
		public XAxis ();
		public double get_ratio ();
		public float tick_interval { get; set; }
		public float tick_length { get; set; }
		public bool visible { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public class YAxis {
		public LiveChart.Path axis;
		public double? fixed_max;
		public LiveChart.Labels labels;
		public LiveChart.Path lines;
		[Version (deprecated = true, deprecated_since = "1.0.0b7", replacement = "ratio is always smart ;)")]
		public bool smart_ratio;
		public LiveChart.Ticks ticks;
		public YAxis (string unit = "");
		public LiveChart.Bounds get_bounds ();
		public string get_max_displayed_value ();
		public double get_ratio ();
		public LiveChart.Ticks get_ticks ();
		public void update (int area_height);
		public bool update_bounds (double value);
		public float ratio_threshold { get; set; }
		public float tick_interval { get; set; }
		[Version (deprecated = true, deprecated_since = "1.0.0b7")]
		public float tick_length { get; set; }
		public string unit { get; set; }
		public bool visible { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public interface Drawable : GLib.Object {
		public abstract void draw (Cairo.Context ctx, LiveChart.Config config);
		public abstract LiveChart.BoundingBox get_bounding_box ();
		public abstract Gdk.RGBA main_color { get; set; }
		public abstract bool visible { get; set; }
	}
	[CCode (cheader_filename = "livechart.h")]
	public struct Boundaries {
		public LiveChart.Boundary x;
		public LiveChart.Boundary y;
		public int width;
		public int height;
	}
	[CCode (cheader_filename = "livechart.h")]
	public struct Boundary {
		public int min;
		public int max;
	}
	[CCode (cheader_filename = "livechart.h")]
	public struct BoundingBox {
		public double x;
		public double y;
		public double width;
		public double height;
	}
	[CCode (cheader_filename = "livechart.h")]
	public struct Dash {
		public double[]? dashes;
		public double offset;
		public Dash ();
	}
	[CCode (cheader_filename = "livechart.h")]
	public struct Padding {
		public LiveChart.AutoPadding smart;
		public int top;
		public int right;
		public int bottom;
		public int left;
		public Padding ();
	}
	[CCode (cheader_filename = "livechart.h")]
	public struct Point {
		public double x;
		public double y;
		public double height;
	}
	[CCode (cheader_filename = "livechart.h")]
	public struct Ticks {
		public Gee.List<float?> values;
		public Ticks ();
	}
	[CCode (cheader_filename = "livechart.h")]
	public struct TimestampedValue {
		public double timestamp;
		public double value;
	}
	[CCode (cheader_filename = "livechart.h")]
	[Flags]
	public enum AutoPadding {
		NONE,
		TOP,
		RIGHT,
		BOTTOM,
		LEFT
	}
	[CCode (cheader_filename = "livechart.h")]
	public errordomain ChartError {
		EXPORT_ERROR
	}
	[CCode (cheader_filename = "livechart.h")]
	public static float cap (float value);
	[CCode (cheader_filename = "livechart.h")]
	public static string format_for_y_axis (string unit, float value);
	[CCode (cheader_filename = "livechart.h")]
	public static Gee.List<float?> golden_divisors (float value);
	[CCode (cheader_filename = "livechart.h")]
	public static bool has_fractional_part (float value);
}
